org.apache.tomcat.util.bcel.classfile

## Class StackMapType

- java.lang.Object
- - org.apache.tomcat.util.bcel.classfile.StackMapType

All Implemented Interfaces:
  Serializable, Cloneable

    public final class StackMapType
    extends Object
    implements Cloneable, Serializable

This class represents the type of a local variable or item on stack used in the StackMap entries.

Author:
  M. Dahm
See Also:
  `StackMapEntry`, `StackMap`, `Constants`, Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`StackMapType(byte type, int index, ConstantPool constant_pool)`

### Method Summary

Methods
`void` `dump(DataOutputStream file)` Dump type entries to file.
`int` `getIndex()`
`boolean` `hasIndex()`
`void` `setConstantPool(ConstantPool constant_pool)`
`void` `setIndex(int t)`
`void` `setType(byte t)`
`String` `toString()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### StackMapType

    public StackMapType(byte type,
                int index,
                ConstantPool constant_pool)

Parameters:
  `type` - type tag as defined in the Constants interface
  `index` - index to constant pool, or byte code offset

### Method Detail

#### setType

    public void setType(byte t)

#### setIndex

    public void setIndex(int t)

#### getIndex

    public int getIndex()

Returns:
  index to constant pool if type == ITEM_Object, or offset in byte code, if type == ITEM_NewObject, and -1 otherwise

#### dump

    public final void dump(DataOutputStream file)
                    throws IOException

Dump type entries to file.

Parameters:
  `file` - Output file stream
Throws:
  `IOException`

#### hasIndex

    public final boolean hasIndex()

Returns:
  true, if type is either ITEM_Object or ITEM_NewObject

#### toString

    public final String toString()

Overrides:
  `toString` in class `Object`
Returns:
  String representation

#### setConstantPool

    public final void setConstantPool(ConstantPool constant_pool)

Parameters:
  `constant_pool` - Constant pool to be used for this object.